#include "MyosinBinding.h"

MyosinBinding::MyosinBinding(double ComingOnRate, double ComingOffRate, double StepSize, RandNumGenerator * Rand) {
   this->ComingOnRate= ComingOnRate;
   this->ComingOffRate = ComingOffRate;
   this->Rand = Rand;
   this->StepSize = StepSize;
   IsBound = true;
}

bool MyosinBinding::TryToBind() {
   if (!IsBound) {
      if (Rand->nextFloat() < ComingOnRate*StepSize){
	 IsBound = true;
	 return true;
      }
   }
   return false;
}

bool MyosinBinding::TryToUnBind() {
   if (IsBound) {
      if (Rand->nextFloat() < ComingOffRate*StepSize){
	 IsBound = false;
	 return true;
      }
   }
   return false;
}

bool  MyosinBinding::TryToChangeState() {
   return (TryToUnBind() || TryToBind());
}

bool MyosinBinding::isBound() {
   return IsBound;
}


