#ifndef POLYMERSDAMPED_H
#define POLYMERSDAMPED_H
#include "GridPeriodic.h"
#include "RandNumGenerator.h"
#include "RungeKutta.h"
#include "SimTypeDef.h"

class Polymer;

class PolymersDamped : public Polymers {

   public:
   PolymersDamped(int NumMon, double StepLength, double Repulsion, int NumChains, double boxwidth, long seed, double SoftCore, double HardCore, SimulationType simtype):
                                Polymers(NumMon, StepLength, Repulsion, NumChains, boxwidth, seed, SoftCore, HardCore, simtype) {};
   PolymersDamped(int NumMon, double StepLength, double Repulsion, int NumChains, vect_f boxsize, long seed, double SoftCore, double HardCore, SimulationType simtype): 
                               Polymers(NumMon, StepLength, Repulsion, NumChains, boxsize, seed, SoftCore, HardCore, simtype) {}; 
   PolymersDamped(int NumMon, double StepLength, double Repulsion, int NumChains, double * boxsize_array, long seed, double SoftCore, double HardCore, char * sim_name):
                      Polymers(NumMon, StepLength, Repulsion, NumChains, boxsize_array, seed, SoftCore, HardCore, sim_name){};
   PolymersDamped(int NumMon): Polymers(NumMon) {};
   void derivs (double t, vect_f * y, vect_f * dydt);
   void setSimulationRungeKutta(double StepSize,double damping);
};

#endif// POLYMERSDAMPED_H
