#You always will be importing a number of modules, or libraries initially
import numpy
from scipy import *
from pylab import *
import scipy
import os
import re


#In python, a function call always begins with "def". 
def get_d(shp):
#   The argument to the function get_d in this case is a "tuple"
#   shp is the variable containing the shape of an array, that is
#   the dimensions (number of columns, and number of rows)

#   Suppose shp = (10,20), then below, you'd see below, that m=10, and n = 20
    m = shp[0]
    n = shp[1]
#   The next line creates an array "dsq" of dimensions shape, all initialized to 0:
    dsq = zeros(shp)
#   Below is the most common way to loop. range(m) creates a list of numbers [0,1,2,...,n-1]
#   We have two for loops, meaning that we'll be assigning values to every element dsq[i,j]
    for i in range(m):
         for j in range(n):
#   Here the R.H.S. calls another function called fold, defined below. "**" means "to the power of"
              dsq[i,j] = fold(i,m)**2 + fold(j,n)**2
#   It hands us back the array dsq filled up with the right values.
    return dsq

# This is another function that is useful when dealing with fourier transforms. As
# a function of x it goes up and then down again, like a triangle with a max at n/2
def fold(x,n):
    if x < n/2:
         return x
    else:
         return n-x


#  This finds the minimum value in an array of numbers
def mini(a):
     return a.flatten()[a.argmin()]

#  This finds the maximum value in an array of numbers
def maxi(a):
     return a.flatten()[a.argmax()]

num_images = 0

#  The next 3 lines iterate over all files that end in ".gif"
#  With each one of these, we perform operations described below.
for rootdir, dirs, files in os.walk('images/'):
    for file in files:
        if re.search(".gif",file):
#            Read in the image. 
             image = imread(os.path.join(rootdir, file))
#            keep track of the number of images that we're processing
             num_images += 1
	     print "processing image ", num_images, " called ", file
#            The array image has an attribute, it's "shape" which is a tuple
#            giving it's dimension, e.g. (200,397).
	     shp = image.shape
#            Now create an image with twice the linear dimensions:
             new_image = zeros((2*image.shape[0],2*image.shape[1]))
#            Now copy image over to new_image and place it in the first
#            quadrant. In this case, instead of having nothing but a ":"
#            we have a minumum and maximum range. So we're copying over
#            everything originally in image and placing in new_image,
#            e.g. copy image[x,y] for 0 <= x <= shp[0]-1 and 0 <= y <= shp[1]-1.

#            The if statement is because some images are black and white and
#            some are color. That means that some are 2d arrays and some are 3d
#            arrays. 
             if size(shp) == 2:
                new_image[0:shp[0],0:shp[1]] = image[0:shp[0],0:shp[1]]
	     elif size(shp) == 3:
#            We just copy over the red component (RGB) of the image that we read
#            in to make it black and white. Obviously this is not the best way
#            of converting a color image to black and white.
                new_image[0:shp[0],0:shp[1]] = image[0:shp[0],0:shp[1],0]
             else:
	        continue 

#            This line does a lot, fortunately we don't have to worry about
#            how it's done. "fft2" is a 2d fourier transform, and "real" takes
#            the real part.
             fft_image = real(fft2(new_image))
             dsq_array = get_d(fft_image.shape)
#            I'm multiplying fft_image by dsq_array.
#            Remember dsq_array multiplies the fourier transform I(k) by k^sq
#            Why do I have to do this? Because otherwise the discretization
#            of image amplitudes totally kills the quality of the image and
#            wouldn't be able to sensibly decode the image.
             fft_image *=  dsq_array
#            png files like positive numbers, so:
             m = mini(fft_image)
             fft_image -= m
#            they like to be scaled. In this case, we'll scale between 0 and 1.
             m = maxi(fft_image)
             fft_image /= m
#            Now write out the image:
             misc.imsave("fft"+str(num_images)+".png",fft_image)


